#include<ctype.h>
#include<process.h>
#include<string.h>
#include<bios.h>
#include<malloc.h>
#include<dos.h>
#include<stdio.h>
#include<conio.h>
#define NOTAS_MAX 60
#define BORDE 1
#define	ESC 27
#define MAX_BASE 10
#define VID_INV 0x70
#define VID_NORM 13
#define BKSP 8
#define NEGRO 0
#define AZUL 1
#define VERDE 2
#define AZUL_BAJO 3
#define ROJO 4

char notas[NOTAS_MAX][39];
void ventana_arriba(int, int);
void ventana_abajo(int );
void ventana_escribecar(int , char);
void ventana_escribet(int, char *);
void ventana_leet(int , char *);
void desactiva(int);
void guarda_video(int);
void restaura_video(int);
void pd_driver();
void vete_xy(int, int);
void borpan();
void escribe_texto(int , int, char *, int );
void escribe_car(int , int, char, int);
void muestra_cabecera(int);
void dibuja_borde(int);
void redim(int);
void mover(int);
void ventana_borra();
void ventana_borraestol(int num);
void ventana(int);
int lee_especial(void);
void decahex();
void block_notas();
//void calc();
void crear_ventana(int ,char * , int, int, int, int, int, int);
char far *mem_video;
int modo_video(void);
int ventana_leecar(int);
int ventana_xy(int, int, int);


struct base_ventana{
	int comienzax, finx, comienzay, finy; /*posicion de la ventana*/
	int curx, cury; /* posicion actual del cursor en la ventana*/
	unsigned char *p; /*puntero al buffer*/
	char *cabecera; /*mensaje de cabecera*/
	int borde; /*borde (si/no)*/
	int activa; /*PANTALLA ACTIVA (si/no)*/
	int color;
	int up;
	int down;
}base[MAX_BASE];

void main(){
	//clrscr();
	union inkey{
		char car[2];
		int i;
	}c;
	int i;
	char car,*temp, t1[]="Editor [esc para salir]";
	borpan();
	vete_xy(0,0);
	/*PRIMERO CREA LAS ESTRUCTURAS DE LAS VENTANAS*/
	crear_ventana(0,t1,0,0,24,79,BORDE, VERDE);
	crear_ventana(1,"Decimal a Hexadecimal", 7,40,10,70,BORDE, ROJO);
	crear_ventana(2,"Calculadora", 8,20,12,60,BORDE, AZUL);
	crear_ventana(3,"Block de notas [F1 para salir]",5,20,17,60, BORDE, ROJO);
	ventana(0);
	do{
		c.i = ventana_leecar(0);
		car = c.i;	 /*USA SOLO EL BAYTE BAJO*/
		if(car=='\r')	/*HACER EXPLICITAMENTE UN CRIF (INICIO OTRA LINEA )*/
			ventana_escribecar(0,'\n');
		switch(c.car[1]){ 	/*COMPRUEBA SI FLECHA O TECLA DE FUNCION*/
			case 59: 	/* F1 EJECUTA LA FUNCION ventana_xy()*/
				ventana(1);
				for(i=0; i<10; ++i)
					if(ventana_xy(1,i,i))
						ventana_escribecar(1,'X');
					getch();
					desactiva(1);
				break;
			case 60:	/* F2 REDIMENCIONA Y MUEVE LA VENTANA*/
				redim(1);
				mover(1);
				break;
			case 61:	/*F3 LLAMA A LA CACULADORA*/
				//calc();
				break;
			case 62:	/*F4 LLAMA AL CONVERSOR DE DECIMAL A HEXADECIMAL*/
				decahex();
				break;
			case 63:	/*F5 LLAMA AL BLOCK DE NOTAS*/
				block_notas();
				break;
			case 72:	/*ARRIBA*/
				ventana_arriba(0,1);
				break;
			case 80:     /*ABAJO*/
				ventana_abajo(0);
				break;
		}
	}while(car!=ESC);
	desactiva(0); /*BORRA LA VENTANA*/
}

/*APARICION DE UNA VENTANA EN PANTALLA*/
void ventana(int num){
	int modov, selecc;
	int x, y;
	modov=modo_video();
	if((modov!=2) && (modov!=3) && (modov!=7)){
		printf("El modo video a de ser el de 80 columnas de texto");
		exit(1);
	}
	/*CALCULA LA DIRECION ADECUADA DE LA RAM EN VIDEO*/

	if(modov==7)
		mem_video = (char far *) 0x80000000;
	else
		mem_video = (char far *) 0xB8000000;

	/*SITUA EN ACTIVA LA VENTANA*/
	if(!base[num].activa){ /*NO ESTA ACTIVA*/
		guarda_video(num);   /*GRAVA LA PANTALLA A LA VISTA */
		base[num].activa=1;  /*ACTIVA LA MARCA DE ACTIVA*/
	}
	if(base[num].borde)
		dibuja_borde(num);
	muestra_cabecera(num);
	x=base[num].comienzax + base[num].curx +1;
	y=base[num].comienzay + base[num].cury +1;
	vete_xy(x,y);
}

void dibuja_borde(int num){
	register int i;
	char far *v, far *t;
	v = mem_video;
	t = v;

	for(i = base[num].comienzax+1; i<base[num].finx; i++){
		v += (i * 160) + base[num].comienzay   * 2 ;
		*v++ = 179;
	       *v = base[num].color;
		v=t;
		v+=(i * 160) + base[num].finy * 2;
		*v++ = 179;
		*v =  base[num].color;
		v=t;
	}

	for(i = base[num].comienzay + 1; i < base[num].finy;i++){
		v+=(base[num].comienzax*160) + i * 2;
		*v++ =196;
		*v = base[num].color;
		v = t;
		v += (base[num].finx * 160) + i * 2;
		*v++ = 196;
		*v = base[num].color;
		v = t;
	}


	/*escribe_car(base[num].comienzax, base[num].comienzay, 218, VID_NORM);*/
	escribe_car(base[num].comienzax, base[num].comienzay, 218, base[num].color);

	/*escribe_car(base[num].comienzax, base[num].finy , 191, VID_NORM);*/
	escribe_car(base[num].comienzax, base[num].finy , 191, base[num].color);

/*	escribe_car(base[num].finx, base[num].comienzay,192, VID_NORM); */
	escribe_car(base[num].finx, base[num].comienzay,192, base[num].color);

	/*escribe_car(base[num].finx, base[num].finy, 217, VID_NORM); */
	escribe_car(base[num].finx, base[num].finy, 217, base[num].color);

}


void crear_ventana(int num,char * titulo, int comienzax, int comienzay, int finx, int finy, int borde, int color){
	unsigned char *p;
	if(num>MAX_BASE){
		printf("Demasiadas ventanas");
		return;
	}

	if(( comienzax > 24 ) || ( comienzax < 0 ) || ( comienzay > 78 ) || ( comienzay < 0 )){
		printf("error de rango");
		return;
	}
	/* RESERVA LA MEMORIA NECESARIA PARA USAR LA VENTANA */


	if((finx > 24) || (finy > 79)){
		printf("no cabe la ventana");
		return;
	}
	/*RESERVA LA MEMORIA NECESARIA PARA PODER USAR LA VENTANA*/

	p = (unsigned char *) malloc(2 * (finx - comienzax + 1) * (finy - comienzay + 1));
	if(!p)
		exit(1);

	/*CONSTRUCCION DE LAS BASES*/
	base[num].comienzax = comienzax;
	base[num].finx = finx;

	base[num].comienzay = comienzay;
	base[num].finy = finy;

	base[num].p = p;
	base[num].cabecera = titulo;
	base[num].borde = borde;
	base[num].activa = 0;
	base[num].curx = 0;
	base[num].cury = 0;
	base[num].color = color;
	return ;
}

int modo_video(){
	union REGS r;
	r.h.ah = 15; /*LEE EL MODO DE VIDEO*/
	return int86(0x10, &r, &r) & 255;
}

void guarda_video(int num){
	register int i, j;
	char *buf_ptr;
	char far *v, far *t;
	buf_ptr = base[num].p;
	v = mem_video;
	for(i = base[num].comienzay; i < base[num].finy + 1; i++)
		for(j = base[num].comienzax; j < base[num].finx + 1; j++){
			t = (v + (j * 160) + i * 2 );
			*buf_ptr++ = *t++;
			*buf_ptr++ = *t;
			*(t-1) = ' '; /* BORRA LA VENTANA*/
		}
}

void vete_xy(int x, int y){
	union REGS r;
	r.h.ah = 2; /*funcion de direcionamiento del cursor*/
	r.h.dl = y; /*COORDENADAS DE LA COLUMNA*/
	r.h.dh = x; /*COORDENADAS DE LA FILA*/
	r.h.bh = 0; /*PAGINA DE VIDEO*/
	int86(0x10, &r, &r);
}

/*BORRA LA PANTALLA*/
void borpan(){
	union REGS r;
	r.h.ah=6; 	//llama a la funcion del BIOS 06H(Scroll Window UP)
	r.h.al=0;       //Nmero de Lineas a enrrollar
	r.h.ch=0;       //FILA superior izquierda
	r.h.cl=0;       //COLUMNA superior izquierda
	r.h.dh=24;      //FILA inferior derecha
	r.h.dl=79;      //COLUMNA inferior derecha
	r.h.bh=7;       //ATRIBUTO para el area area limpiada
	int86(0x10, &r, &r); //VER PROTOTIPO DE FUNCION int86
}
                                  
void escribe_car(int x, int y, char car, int atrib){
	register int i;
	char far *v;
	v=mem_video;
	v += (x * 160) + y * 2;
	*v++ = car; /*ESCRIBE EL CARACTER*/
	*v=atrib;
}

void desactiva(int num){
	/*COLOCA EL CURSOR EN LA POSICION DE LA ESQUINA SUPERIOR IZQUIERDA*/
	base[num].curx=0;
	base[num].cury=0;
	restaura_video(num);
}


void ventana_escribecar(int num, char car){
	register int x,y;
	char far *v;
	 char temp;
	 temp = car;
	/*SE ASEGURA DE QUE LA VENTANA ESTE ACTIVA*/
	if(!base[num].activa)
		return;
	x = base[num].curx + base[num].comienzax + 1;
	y = base[num].cury + base[num].comienzay + 1;
	v = mem_video;
	v += (x * 160) + y * 2;
	if(y >= base[num].finy){
		return;
	}

	if(x >= base[num].finx){
		return;
	}

	if(car=='\n'){		/*CABECERA DE SALTO DE LINEA*/
		x++;
		y =  base[num].comienzax + 1;
		v = mem_video;
		v += (x * 160) + y * 2;		/*CALCULA LA DIRECCION*/
		base[num].curx++;  /*INCREMENTO DE X*/
		base[num].cury=0;	/*REINICIA Y */
	}
	else{
		base[num].cury++;
		*v++=car; /*ESCRIBE EL CARACTER*/
		*v++=VID_NORM;	/*ATRIBUTO DE VIDEO NORMAL*/
	}

	ventana_xy(num, base[num].curx, base[num].cury);
	return;

}

int ventana_leecar(int num){
	union inkey{
		char car[2];
		int i;
	}c;
	if(!base[num].activa)    /*VENTANA NO ACTIVA*/
		return 0;
	ventana_xy(num, base[num].curx, base[num].cury);
	c.i=bioskey(0); /*LEE LA TECLA*/

	if(c.car[0]){
		switch(c.car[0]){
			case '\r': /*SE HA PULSADO INTRO*/
				break;
			case BKSP: /*RETROCESO BORRAR*/
				break;
			default:
				if(base[num].cury + base[num].comienzay < base[num].finy - 1){
					escribe_car(base[num].comienzax + base[num].curx + 1, base[num].comienzay + base[num].cury + 1, c.car[0], VID_NORM);
					base[num].cury++;
				}
		}
		if(base[num].curx < 0) base[num].curx=0;
		if(base[num].curx + base[num].comienzax > base[num].finx - 2);
			base[num].curx--;
		ventana_xy(num, base[num].curx+1, base[num].cury);
	}
	return c.i;
}


int ventana_xy(int num, int x, int y){
	if(x < 0 || x + base[num].comienzax >= base[num].finx - 1)
		return 0;
	if(y < 0 || y + base[num].comienzay  >= base[num].finy - 1)
		return 0;
	base[num].curx = x;
	base[num].cury = y;
	vete_xy( base[num].comienzax + x + 1, base[num].comienzay + y + 1);
	return 1;
}

void redim(int num){
	char car;
	int x, y, comienzax, comienzay;
	/*ACTIVA SI ES NECESARIO*/
	if(!base[num].activa)
		ventana(num);
	comienzax = x = base[num].comienzax;
	comienzay = y = base[num].comienzay;
	ventana_xy(num, 0 , 0);
	do{
		car = lee_especial();
		switch(car){
			case 75: /*IZQUIERDA*/
				comienzay--;
				break;
			case 77: 	/* DERECHA */
				comienzay++;
				break;
			case 72: 	/* ARRIBA */
				comienzax--;
				break;
			case 80: 	/* ABAJO */
				comienzax++;
				break;
			case 71:	/* ARRIBA IZQUIERDA */
				comienzax--; comienzay--;
				break;
			case 73:	/* ARRIBA DERECHA */
				comienzax--; comienzay++;
				break;
			case 79:	/* ABAJO IZQUIERDA */
				comienzax++; comienzay--;
				break;
			case 81:	/* ABAJO DERECHA */
				comienzax++; comienzay++;
				break;
			case 60: 	/* F2 CANCELA Y VUELVE AL TAMAO ORIGINAL */
				comienzax = x; comienzay = y;
				car = 59;
				break;
		}
		/* COMPRUEBA SI ESTA FUERA DEL RANGO*/
		if(comienzax < 0) comienzax++;
		if(comienzax >=base[num].finx) comienzax--;
		if(comienzay < 0) comienzay++;
		if(comienzay >=base[num].finy) comienzay--;
		desactiva(num);
		base[num].comienzax = comienzax;
		base[num].comienzay = comienzay;
		ventana(num);
	}while(car != 59);
	desactiva(num);
}

/*DEVUELVE EL CODIGO DE POSICION DE LAS TECLAS DE FLECHA Y FUNCION*/

int lee_especial(void){
	union inkey{
		char car[2];
		int i;
	}c;
	while(!bioskey(1)); 	/*ESPERA LA PULSACION*/
	c.i = bioskey(0);
	return c.car[1];
}

void restaura_video(int num){
	register int i,j;
	char far *v, far *t;
	char *buf_ptr;

	buf_ptr = base[num].p;
	v = mem_video;
	t = v;
	for(i = base[num].comienzay; i < base[num].finy + 1; i++)
		for(j = base[num].comienzax; j < base[num].finx + 1; j++){
			v=t;
			v += (j * 160) + i * 2;
			*v++ = *buf_ptr++; /* ESCRIBE EL CARACTER */
			*v = *buf_ptr++;   /* ESCRIBE EL ATRIBUTO */
		}
		base[num].activa = 0	/*RESTAURA VIDEO */;
}


void muestra_cabecera(int num){
	register int y, lon;
	y = base[num].comienzay;
	/* CALCULA LA POSICION ADECUADA PARA CENTRAR EL TITULO*/
	lon = strlen(base[num].cabecera);
	lon = (base[num].finy - y - lon)/2;
	if(lon < 0)
		return; /* NO LO MUESTRA*/
	y = y + lon;
	escribe_texto(base[num].comienzax, y, base[num].cabecera, VID_NORM);
}

void escribe_texto(int x, int y, char *p, int atrib){
	register int i;
	char far *v;
	v=mem_video;
	v += (x * 160) + y * 2; /* CALCULA LA DIRECCION */
	for(i = y; *p; i++){
		*v++ = *p++; /*ESCRIBE EL CARACTER */
		*v++ = atrib; /* ESCRIBE EL ATRIBUTO */
	}
}


void mover(int num){
	char car;
	int x, y, ex, ey, comienzax, comienzay, finx, finy;
	/* ACTIVA SI ES NECESARIO */
	if(!base[num].activa)
		ventana(num);
	comienzax = x = base[num].comienzax;
	comienzay = y = base[num].comienzay;
	finx = ex = base[num].finx;
	finy = ey = base[num].finy;
	ventana_xy(num, 0, 0);
	do{
		car = lee_especial();
		switch(car){
			case 75:	/* IZQUIERDA */
				comienzay--;
				finy--;
				break;
			case 77:	/* DERECHA */
				comienzay++;
				finy++;
				break;
			case 72:	/* ARRIBA */
				comienzax--;
				finx--;
				break;
			case 80:      	/* ABAJO */
				comienzax++;
				finx++;
				break;
			case 71:	/* ARRIBA IZQUIERDA  */
				comienzax--; comienzay--;
				finx--; finy--;
				break;
			case 73: 	/* ARRIBA DERECHA */
				comienzax--; comienzay++;
				finx--; finy++;
				break;
			case 79:	/* ABAJO IZQUIERDA */
				comienzax++; comienzay--;
				finx++; finy--;
				break;
			case 81:	/* ABAJO DERECHA */
				comienzax++; comienzay++;
				finx++; finy++;
				break;
			case 60:     	/* CANCELA Y VUELVE A LA POSICION ORIGINAL */
				comienzax = x;
				comienzay = y;
				finx = ex;
				finy = ey;
				car = 59;
				break;
		}
		/* COMPRUEBA SI ESTA FUERA DEL RANGO */
		if(comienzax < 0){
			comienzax++;
			finx++;
		}

		if(finx >= 25){
			comienzax--;
			finx--;
		}

		if(comienzay < 0){
			comienzay++;
			finy++;
		}

		if(finy >= 79){
			comienzay--;
			finy--;
		}
		desactiva(num);
		base[num].comienzax = comienzax;
		base[num].comienzay = comienzay;
		base[num].finx = finx;
		base[num].finy = finy;
		ventana(num);
	}while(car != 59);
	desactiva(num);
}

/* MUEVE EL CURSOR UNA LINEA HACIA ARRIBA DEVULVE UN NUMERO DISTINTO DE
CERO SI LA OPERACION TUVO EXITO, 0 EN OTRO CASO*/

void ventana_arriba(int num, int i){
	void window_down(int);
	if(base[num].curx==0 && base[num].up > 0){
		base[num].up--;
		window_down(num);
		ventana_escribet(3, notas[i]);
		ventana_xy(num,base[num].curx,0);
	}
	if(base[num].curx > 0){
		base[num].curx--;
		ventana_xy(num, base[num].curx, base[num].cury);
	}
	return;
}


/* MUEVE EL CURSOR UNA LINEA HACIA ABAJO DEVULVE UN NUMERO DISTINTO DE
CERO SI LA OPERACION TUVO EXITO, 0 EN OTRO CASO*/
void ventana_abajo(int num){
	if(base[num].curx < base[num].finx - base[num]. comienzax - 1){
		base[num].curx++;
		ventana_xy(num, base[num].curx, base[num].cury);
		return;
	}
}

/*RETROCEDER UN CARACTER*/
void ventana_retro(int num){
	if(base[num].cury > 0){
		base[num].cury--;
		ventana_xy(num, base[num].curx, base[num].cury);
		ventana_escribecar(num, ' ');
		base[num].cury--;
		ventana_xy(num, base[num].curx, base[num].cury);
	}
}

/*CONVERSOR DE DECIMAL A HEXADECIMAL*/

void decahex(){
	char ent[80], sal[80];
	int n;
	ventana(1);
	do{
		ventana_xy(1,0,0); 		/* VA A LA PRIMERA LINEA*/
		ventana_borraestol(1);		/*BORRA LA LINEA*/
		ventana_escribet(1, "Dec: "); 	/*Pide el dato*/
		ventana_leet(1, ent); 		/*Lee el numero*/
		ventana_escribecar(1, '\n'); 	/*VA A LA SIGUIENTE LINEA*/
		ventana_borraestol(1); 		/*LA BORRA*/
		sscanf(ent,"%d", &n);		/*CONVERSION A FORMATO INTERNO*/
		sprintf(sal,"%s%X","Hex :",n);	/*VA A LA SIGUIENTE LINEA*/
		ventana_escribet(1, sal);	/* DA SALIDA AL VALOR HEX*/
	}while(*ent);
	desactiva(1);
}

/*BORRA EL FINAL DE LA LINEA*/
void ventana_borraestol(int num){
	register int i,x,y;
	x = base[num].curx;
	y = base[num].cury;
	ventana_xy(num, base[num].curx, base[num].cury);
	for(i = base[num].curx; i< base[num].finy - 1; ++i)
		ventana_escribecar(num, ' ');
		ventana_xy(num, x,y);
}

void ventana_leet(int num, char *s){
	char car, *temp;
	temp = s;
	for(;;){
		car = ventana_leecar(num);
		switch(car){
			case '\r':	/*SE PULSO LA TECLA ENTER*/
				*s= '\0';
				return;
			case BKSP:	/*SE PULSO LA TECLA DE RETROCESO*/
				if(s > temp){
					s--;
					base[num].cury--;
					if(base[num].cury < 0)
						base[num].cury = 0;
					ventana_xy(num, base[num].curx, base[num].cury);
					escribe_car(base[num].comienzax + base[num].curx+1 , base[num].comienzay + base[num].cury + 1, ' ', VID_NORM);
				}
				break;
			default: *s = car;
			s++;
		}
	}
}


/*ESCRIBE TEXTO EN LA POSICION ACUAL DEL CURSOR*/
void ventana_escribet(int num, char *str){
	/*VERIFICA SI LA VENTANA ESTA ACTIVA*/
	if(!base[num].activa) return;

	for(; *str; str++)
		ventana_escribecar(num, *str);
	return;
}

//BLOCK DE NOTAS
void block_notas(void){
	void put_cursor(int);
	void window_up(int num);
	static primero=1;
	int i,j;
	int up=0;
	union inkey{
		char car[2];
		int i;
	}c;
	char car;
	/*INICIALIZA LA MATRIZ DE NOTAS SI ES NECESARIO*/
	if(primero){
		for(i=0; i<NOTAS_MAX; ++i)
			*notas[i]='\0';
		primero = !primero;
	}
	ventana(3);
	/*MUESTRA LAS NOTAS EXISTENTES*/
	for(i = 0; i < NOTAS_MAX; i++){
		if(*notas[i]){
			ventana_escribet(3, notas[i]);
			ventana_escribecar(3,'\n');
		}
	}
	i=0;
	ventana_xy(3,0,0);
	for(;;){
		c.i = ventana_leecar(3); //LEE LA TECLA PULSADA
		if(tolower(c.car[1])==59){	//F1 para salir
			desactiva(3);
			break;
		}
	       //SI SE HA PULSADO UNA TECLA CORRECTA EN LA NOTA
		if(isprint(c.car[0]) || c.car[0]==BKSP){
			notas[i][0] = c.car[0];
			j = 1;
			do{
				if(base[3].cury == (base[3].finy - base[3].comienzay) - 2){
					base[3].curx++;
					base[3].cury=0;
					ventana_xy(3, base[3].curx, base[3].cury);
					i++;
					j=0;
					put_cursor(3);
				}


				car = ventana_leecar(3);
				if(car=='\r') {
					notas[i][j]='\0';
					break;
				}
				if(car == BKSP){
					if(j > 0){
						j--;
						ventana_retro(3);
					}
				}
				else{
					notas[i][j++] = car;
				}
			}while(notas[i][j] != '\r');
			notas[i][j] = '\0';
			i++;
			ventana_escribecar(3,'\n');
		}
		else{  //ES UNA TECLA ESPECIAL
			switch(c.car[1]){
				case 72:	//FLECHA ARRIBA
					if(i > 0){
						i--;
						ventana_arriba(3,i);
					}
				break;
				case 77: //FLECHA DERECHA
					if(base[3].cury < (base[3].finy-base[3].comienzay)-2)
						vete_xy(base[3].curx,base[3].cury++);
				break;

				case 80:	//FLECHA ABAJO
					if(i < NOTAS_MAX - 1){
						i++;
						ventana_abajo(3);
					}
				break;

				case 59:	//F1 PARA SALIR
					desactiva(3);
				break;
			}
		}
	}
}


void put_cursor(int num){
	void window_up(int);
	if(base[3].curx >= (base[3].finx - base[3].comienzax -1) && (base[num].finy - base[num].comienzay )){
		window_up(3);
		base[num].curx=base[num].curx - 1;
		base[num].up++;
	}
}


void window_up(int num){
	union REGS r;
	r.h.ah=6; 	//llama a la funcion del BIOS 06H(Scroll Window UP)
	r.h.al=1;       //Nmero de Lineas a enrrollar
	r.h.ch=6;       //FILA superior izquierda
	r.h.cl=21;       //COLUMNA superior izquierda
	r.h.dh=16;      //FILA inferior derecha
	r.h.dl=59;      //COLUMNA inferior derecha
	r.h.bh=7;       //ATRIBUTO para el area area limpiada
	int86(0x10, &r, &r); //VER PROTOTIPO DE FUNCION int86
}

void window_down(int num){
	union REGS r;
	r.h.ah=7; 	//llama a la funcion del BIOS 06H(Scroll Window UP)
	r.h.al=1;       //Nmero de Lineas a enrrollar
	r.h.ch=6;       //FILA superior izquierda
	r.h.cl=21;       //COLUMNA superior izquierda
	r.h.dh=16;      //FILA inferior derecha
	r.h.dl=59;      //COLUMNA inferior derecha
	r.h.bh=7;       //ATRIBUTO para el area area limpiada
	int86(0x10, &r, &r); //VER PROTOTIPO DE FUNCION int86
}